# OBJ - timestamped JSON objects
#
# obj/bus.py
#
# Copyright 2017,2018 B.H.J Thate
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy 
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights 
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
# copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice don't have to be included.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN 
# THE SOFTWARE.
#
# 18-09-2018 As the creator of this file, I disclaim all rights on this file. 
#
# Bart Thate
# Heerhugowaard
# The Netherlands

"""  bus module, post messages to bots.  """

__version__ = 1

## imports 

import obj.base

import logging
import random

## classes

class Fleet(obj.base.Dotted):

    """ A bus can be used to send text to registered bots. """

    bots = []

    def add(self, bot):
        """ add a bots. """
        Fleet.bots.append(bot)

    def announce(self, txt):
        """ announce to all bots. """
        for bot in Fleet.bots:
             bot.announce(txt)
    
    def by_type(self, btype):
        """ return bots by type. """
        for bot in Fleet.bots:
            if str(btype).lower() in str(type(bot)).lower():
                return bot

    def get_bot(self, id):
        """ return a listener with corresponding id. """
        for bot in Fleet.bots:
            if id in repr(bot):
                return bot

    def match(self, m):
        """ search for matching bot. """
        for bot in Fleet.bots:
            if m.lower() in repr(bot):
                return bot

    def remove(self, bot):
        """ remove a listener. """
        Fleet.bots.remove(listener)

    def say(self, id, channel, txt):
        """ say some text to a listener. """
        bot = self.get_bot(id)
        if bot:
            bot.say(channel, txt)
